#ifndef BARMAN_H
#define BARMAN_H

#include <JTC/JTC.h>
#include "birreria.h"
#include "cout.h"

extern Birreria baffo_biondo;

class Barman : public JTCThread {

private:
    int id;

public:
    Barman ( int i ) : id(i) {}
    virtual void run() {
        srand ( time (0) );
		while ( true ) {
		    sleep ( rand() % 100 );
		    coutSync << "il barman " << id << " e' al bancone degli ordini." << endl;
            int num_birre = baffo_biondo.getOrdine();
            coutSync << "il barman " << id << " ha prelevato un ordine di " << num_birre << " birre." << endl;
            sleep ( rand () % ( 1000 * num_birre ) );
            coutSync << "il barman " << id << " ha spillato " << num_birre << " birre." << endl;
            for ( int i = 1; i <= num_birre; i++ ) {
                baffo_biondo.putBirra();
                coutSync << "il barman " << id << " ha posato la " << i << "^a birra sul bancone." << endl;
            }
        }
    }

};

#endif
