#ifndef CLIENTE_H
#define CLIENTE_H

#include <JTC/JTC.h>
#include "birreria.h"
#include "cout.h"

extern Birreria baffo_biondo;

class Cliente : public JTCThread {

private:
    int id;

public:
    Cliente ( int i ) : id(i) {}
    virtual void run() {
        srand ( time (0) );
		while ( true ) {
            sleep ( rand() % 1000 );
            coutSync << "il cliente " << id << " entra nella birreria." << endl;
            int num_birre = rand() % 10 + 1;
            baffo_biondo.putOrdine(num_birre);
            coutSync << "il cliente " << id << " ha ordinato " << num_birre << " birre" << endl;
            sleep ( rand () % ( 1000 * num_birre ) );
            baffo_biondo.getBirre(num_birre);
            coutSync << "il cliente " << id << " ha prelevato " << num_birre << " birre" << endl;
        }
    }

};

#endif
