
#ifndef CONSOLE_STREAM_H
#define CONSOLE_STREAM_H

#include <JTC/JTC.h>
#include <iostream>
#include <string>

using namespace std;

#define COUTWRAP {JTCSynchronized(*this);cout << d;return *this;}

// libreria per evitare che le cout vengano interrotte durante la stampa.
// usare coutSync al posto di cout
// attenzione:  coutSync << "a" << "b";  equivalente a
// coutSync << "a";
// coutSync << "b";
// dunque la stampa pu essere interrotta tra la stampa di "a" e la stampa di "b".

class ConsoleStream : public JTCMonitor

{
public:
         ConsoleStream& operator<<(const char * d) COUTWRAP
inline   ConsoleStream& operator<<(const unsigned char *d) COUTWRAP
inline   ConsoleStream& operator<<(const signed char *d) COUTWRAP
inline   ConsoleStream& operator<<(char d) COUTWRAP
         ConsoleStream& operator<<(unsigned char d) COUTWRAP
inline   ConsoleStream& operator<<(signed char d) COUTWRAP
         ConsoleStream& operator<<(short d) COUTWRAP
         ConsoleStream& operator<<(unsigned short d) COUTWRAP
         ConsoleStream& operator<<(int d) COUTWRAP
         ConsoleStream& operator<<(unsigned int d) COUTWRAP
         ConsoleStream& operator<<(long d) COUTWRAP
         ConsoleStream& operator<<(unsigned long d) COUTWRAP
inline   ConsoleStream& operator<<(float d) COUTWRAP
         ConsoleStream& operator<<(double d) COUTWRAP
         ConsoleStream& operator<<(long double d) COUTWRAP
         ConsoleStream& operator<<(const void *d) COUTWRAP
         ConsoleStream& operator<<(string d) COUTWRAP
         ConsoleStream& operator<<(streambuf* d) COUTWRAP
         ConsoleStream& operator<<(ostream& (*d)(ostream&)) COUTWRAP
         
};


extern ConsoleStream coutSync;

#endif
