#!/usr/bin/perl


open(SOLVED,">solvedseq.txt") || die("impossibile aprire il file ...\n");

$_ = <STDIN>;

while ( $_ ) {
  
    if ( /^>([0-9]+),([0-9]+)/ ) {
        $N = $1;
        $M = $2;
        @sequenza = ();
        push(@sequenza, $_);

        #
        # Ciclo interno di base, simile allo stesso ciclo visto in check.pl
        # Corregge eventuali numeri non divisibili per M, aggiungendo la quantit giusta.
        #

        while (($_ = <STDIN>) && ($_ !~ /^>/))
        {
            if ( $_ % $M != 0 ) {
                #
                # Corregge il numero in maniera tale da renderlo divisibile per M, e aggiunge un "\n".
                # 
                $_ = ($_ + $M - $_% $M) . "\n";
            }
            push(@sequenza, $_);
        }
        
        #
        # Ciclo per aggiungere eventuali numeri mancanti, se ho contato meno di $N valori
        #
        
        for ( $K = $N-$#sequenza; $K > 0; $K-- ) {
            push(@sequenza, ($M*$K)."\n");
        }
        
        # Ciclo per rimuovere eventuali numeri in pi.
        
        pop(@sequenza) while( $#sequenza > $N );
        
        #
        # Cambio di $", similare all'esercizio check.pl
        #
        
        $" = ""; 
        
        print SOLVED "@sequenza";
    }
}

close(SOLVED);
